package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLMultiAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLMultiAff extends JNIObject implements IISLStandardMapMethods {
	
	/* @generated */
	protected ISLMultiAff(long ptr) {
		/*** PROTECTED REGION ID(ISLMultiAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLMultiAff build(long ptr) {
		return new ISLMultiAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLMultiAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}

	/**
	 * 
	 * @return the list of quasi-Aff expressions in the multi_aff object.
	 */
	public List<ISLAff> getAffs() {
		int n = this.getNbOutputs();
		List<ISLAff> res = new ArrayList<ISLAff>();
		for (int i = 0; i < n; i++) {
			res.add(getAff(i));
		}
		return res;
	}
	
	public boolean isIdentity() {
		if (this.getNbInputs() != this.getNbOutputs()) return false;
		return this.isPlainEqual(ISLMultiAff.buildIdentity(getSpace()));
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_multi_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLMultiAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_read_from_str) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_zero 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiAff buildZero(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_zero) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_zero(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_identity 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiAff buildIdentity(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_identity) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_identity(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_domain_map 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiAff buildDomainMap(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_domain_map) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_domain_map(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_range_map 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiAff buildRangeMap(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_range_map) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_range_map(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_project_out_map 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiAff buildProjectOutMap(ISLSpace space, ISLDimType type, int first, int n) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_project_out_map) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_project_out_map(getNativePtr(space), type.getValue(), first, n));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_from_aff_list 
	 * 
	@take space list
	 * @generated
	**/
	 public static ISLMultiAff buildFromAffList(ISLSpace space, ISLAffList list) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_from_aff_list) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space, list);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_from_aff_list(getNativePtr(space), getNativePtr(list)));
			} finally {
				taken(space);
				taken(list);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLMultiAff maff, int format) { 
		/*** PROTECTED REGION ID(static_isl_multi_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_aff_to_string(getNativePtr(maff), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_basic_set_from_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet toBasicSet() {
		/*** PROTECTED REGION ID(isl_basic_set_from_multi_aff) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_from_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_set_from_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSet() {
		/*** PROTECTED REGION ID(isl_set_from_multi_aff) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_from_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap toBasicMap() {
		/*** PROTECTED REGION ID(isl_basic_map_from_multi_aff) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_from_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_map_from_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toMap() {
		/*** PROTECTED REGION ID(isl_map_from_multi_aff) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_pw_aff_from_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiPWAff toMultiPWAff() {
		/*** PROTECTED REGION ID(isl_multi_pw_aff_from_multi_aff) DISABLED START ***/
		ISLMultiPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiPWAff.build(ISLNative.isl_multi_pw_aff_from_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_from_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff toMultiUnionPWAff() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_from_multi_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_from_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_multi_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_multi_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_multi_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_multi_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_copy 
	 * 
	 * @generated
	**/
	public ISLMultiAff copy() {
		/*** PROTECTED REGION ID(isl_multi_aff_copy) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_multi_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_multi_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_get_domain_space 
	 * 
	 * @generated
	**/
	public ISLSpace getDomainSpace() {
		/*** PROTECTED REGION ID(isl_multi_aff_get_domain_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_multi_aff_get_domain_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLMultiAff alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_multi_aff_align_params) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_multi_aff_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_aff_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff insertDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_multi_aff_insert_dims) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_insert_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_multi_aff_add_dims) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_multi_aff_drop_dims) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_multi_aff_move_dims) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_multi_aff_set_dim_name) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_get_aff 
	 * 
	 * @generated
	**/
	public ISLAff getAff(int pos) {
		/*** PROTECTED REGION ID(isl_multi_aff_get_aff) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_multi_aff_get_aff(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_set_aff 
	 * 
	 * @take this aff
	 * @generated
	**/
	public ISLMultiAff setAff(int pos, ISLAff aff) {
		/*** PROTECTED REGION ID(isl_multi_aff_set_aff) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_set_aff(getNativePtr(this), pos, getNativePtr(aff)));
			} finally {
				taken(this);
				taken(aff);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLMultiAff maff2) {
		/*** PROTECTED REGION ID(isl_multi_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_aff_plain_is_equal(getNativePtr(this), getNativePtr(maff2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff negate() {
		/*** PROTECTED REGION ID(isl_multi_aff_neg) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_floor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff floor() {
		/*** PROTECTED REGION ID(isl_multi_aff_floor) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_floor(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_flatten_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff flattenDomain() {
		/*** PROTECTED REGION ID(isl_multi_aff_flatten_domain) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_flatten_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_flatten_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiAff flattenRange() {
		/*** PROTECTED REGION ID(isl_multi_aff_flatten_range) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_flatten_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_add 
	 * 
	 * @take this maff2
	 * @generated
	**/
	public ISLMultiAff add(ISLMultiAff maff2) {
		/*** PROTECTED REGION ID(isl_multi_aff_add) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, maff2);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_add(getNativePtr(this), getNativePtr(maff2)));
			} finally {
				taken(this);
				taken(maff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_sub 
	 * 
	 * @take this ma2
	 * @generated
	**/
	public ISLMultiAff sub(ISLMultiAff ma2) {
		/*** PROTECTED REGION ID(isl_multi_aff_sub) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, ma2);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_sub(getNativePtr(this), getNativePtr(ma2)));
			} finally {
				taken(this);
				taken(ma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_product 
	 * 
	 * @take this ma2
	 * @generated
	**/
	public ISLMultiAff product(ISLMultiAff ma2) {
		/*** PROTECTED REGION ID(isl_multi_aff_product) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, ma2);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_product(getNativePtr(this), getNativePtr(ma2)));
			} finally {
				taken(this);
				taken(ma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMultiAff gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_multi_aff_gist_params) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMultiAff gist(ISLSet context) {
		/*** PROTECTED REGION ID(isl_multi_aff_gist) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_pullback_multi_aff 
	 * 
	 * @take this ma2
	 * @generated
	**/
	public ISLMultiAff pullback(ISLMultiAff ma2) {
		/*** PROTECTED REGION ID(isl_multi_aff_pullback_multi_aff) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, ma2);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_pullback_multi_aff(getNativePtr(this), getNativePtr(ma2)));
			} finally {
				taken(this);
				taken(ma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_aff_flat_range_product 
	 * 
	 * @take this ma2
	 * @generated
	**/
	public ISLMultiAff flatRangeProduct(ISLMultiAff ma2) {
		/*** PROTECTED REGION ID(isl_multi_aff_flat_range_product) DISABLED START ***/
		ISLMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, ma2);
			try {
				res = ISLMultiAff.build(ISLNative.isl_multi_aff_flat_range_product(getNativePtr(this), getNativePtr(ma2)));
			} finally {
				taken(this);
				taken(ma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLMultiAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
